#!/usr/bin/perl
# -- lyrics retrieval script for xmms
# -- 01/2006 by camico A7 users D07 sourceforge D07 net

use LWP::Simple qw(get);
eval "use Encode qw(from_to)"; $ENCODE_LOADED = not $@;
my $lyrdir = shift;
DBG( "Artist: $artist\nTitle:  $title" );

# =============================================================================
my $DEBUG = 1;

# =============================================================================

my $sep = "__00__";
my $string = join( " ", @ARGV );
my @info = split / $sep /, $string;
my $artist = $info[0];
my $title = $info[1];
my $realtitle = $info[1];
my $lyrfile = $lyrdir.$artist." - ".$title.".lyrics.xml";
# -----------------------------------------------------------------------------
my $html = "";
DBG( "Artist: $artist\nTitle:  $title" );

# see if another title was selected manually
# ------------------------------
if( open INFO, "<$lyrdir/$artist - $title.info" ) {
    my $lastline = "";
    while( $line = <INFO> ) {
        chomp($line);
        if( $lastline eq "SONG" ) {
            $realtitle = $line;
        }
        if( $lastline eq "ARTIST" ) {
            $realartist = $line;
        }
        $lastline = $line;
    } close INFO;
	DBG( "realtitle: $realtitle" );
	DBG( "realartist: $realartist" );    
}

# 1. search
# ------------------------------
$realartist =~ s/&/%26/g;
my $url = "http://lyrc.com.ar/en/tema1en.php?artist=".$realartist."&songname=".$realtitle;
DBG($url);
$html = get $url;
notfound("Server not reachable.", 0) if not $html;

$html =~ s/<b>$realtitle.*?$realartist<\/u>//gis;

if( $html =~ /<font[ ]*?size[ ]*?=\'2\'.*?<\/font>(.*?)(<br><br>|<p><hr)/s ) {
    $lyrics = $1;
    $lyrics =~ s/<.*?>//gis; # remove all tags
    $lyrics =~ s/\n\n//gis;
    DBG( "Lyrics: $lyrics" );
}
elsif( $html =~ /Suggestions : / ) {
#    @url      = ($html =~ /(tema1en\.php\?hash=.*?)\"/gs);
    @artist_names = ($html =~ /<font color=\'white\'>(.*?) - .*?<\/font>/gs);
    @artist_songs = ($html =~ /<font color=\'white\'>.*? - (.*?)<\/font>/gs);
    write_result_list( );
}
else {
    notfound("Nothing appropriate.", 0);
}

# Success
# -----------------------------------------------------------------------------
if( substr( $lyrics, 0, 1 ) eq "\n" ) { $lyrics = substr( $lyrics, 1 ); }

$realartist =~ s/\&/\&amp;/g;
$realtitle =~ s/\&/\&amp;/g;
open FILE, ">:utf8", $lyrfile;
print FILE <<STOP;
<?xml version="1.0" encoding="utf-8" ?>
    <lyrc><result>
    <name>$realtitle</name>
    <group>$realartist</group>
    <lyric>$lyrics</lyric>
    </result></lyrc>
STOP
close FILE;
exit;

# -----------------------------------------------------------------------------
sub write_result_list {
    my $err = shift;
    my $searchOn = shift;
    my $i = 0;
    $err =~ s/\&/\&amp;/g;
    DBG( "artist's songs:" );

    open FILE, ">:utf8", $lyrfile;
    print FILE '<?xml version="1.0" encoding="utf-8" ?><lyrc><suggest>';
    foreach( @artist_songs ) {
	$group = $artist_names[$i++];
	$group =~ s/<.*>//g;
	$group =~ s/&/&amp;/g;	
        $name = $_;
        $name =~ s/&/&amp;/g;
	$name =~ s/<.*>//g;
        print FILE '<song><name>'.$name.'</name><group>'.$group.'</group></song>';
    }
    if( $err ) { print FILE '<message>'.$err.'</message>'; }
    if( $searchOn ) { print FILE '<searchOn />'; }
    print FILE '</suggest></lyrc>';
    close FILE;
    exit;
}

# -----------------------------------------------------------------------------
sub notfound {
    my $err = shift;
    my $searchOn = shift;
    DBG( "lyrics for \"$artist - $title\" not found :( ... [$err]" );
    write_result_list( $err, $searchOn );
    exit;
}
# -----------------------------------------------------------------------------
sub DBG {
    my $str = shift;
    if( $DEBUG ) {
	$str =~ s/\n/\n       /g;
	print "[Lyrc] $str\n";
    }
}
